/* engine.c generated by valac 0.37.2, the Vala compiler
 * generated from engine.vala, do not modify */

/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define EUCLIDE_COMPLETION_TYPE_PARSER (euclide_completion_parser_get_type ())
#define EUCLIDE_COMPLETION_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParser))
#define EUCLIDE_COMPLETION_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParserClass))
#define EUCLIDE_COMPLETION_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EUCLIDE_COMPLETION_TYPE_PARSER))
#define EUCLIDE_COMPLETION_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EUCLIDE_COMPLETION_TYPE_PARSER))
#define EUCLIDE_COMPLETION_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParserClass))

typedef struct _EuclideCompletionParser EuclideCompletionParser;
typedef struct _EuclideCompletionParserClass EuclideCompletionParserClass;
typedef struct _EuclideCompletionParserPrivate EuclideCompletionParserPrivate;
enum  {
	EUCLIDE_COMPLETION_PARSER_DUMMY_PROPERTY,
	EUCLIDE_COMPLETION_PARSER_LAST_PROPERTY
};
static GParamSpec* euclide_completion_parser_properties[EUCLIDE_COMPLETION_PARSER_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _EuclideCompletionParser {
	GObject parent_instance;
	EuclideCompletionParserPrivate * priv;
	GeeHashMap* text_view_words;
	gboolean parsing_cancelled;
};

struct _EuclideCompletionParserClass {
	GObjectClass parent_class;
};

struct _EuclideCompletionParserPrivate {
	GeeArrayList* words;
	GRecMutex __lock_words;
	gchar* last_word;
};


static gpointer euclide_completion_parser_parent_class = NULL;
static GType euclide_completion_parser_type_id = 0;

GType euclide_completion_parser_get_type (void) G_GNUC_CONST;
#define EUCLIDE_COMPLETION_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParserPrivate))
#define EUCLIDE_COMPLETION_PARSER_MINIMUM_WORD_LENGTH 3
#define EUCLIDE_COMPLETION_PARSER_MAX_TOKENS 1000000
#define EUCLIDE_COMPLETION_PARSER_delimiters " .,;:?{}[]()0123456789+-=&|-<>*\\/\n\t\'\""
gboolean euclide_completion_parser_is_delimiter (EuclideCompletionParser* self, gunichar c);
EuclideCompletionParser* euclide_completion_parser_new (void);
EuclideCompletionParser* euclide_completion_parser_construct (GType object_type);
void euclide_completion_parser_add_last_word (EuclideCompletionParser* self);
static void euclide_completion_parser_add_word (EuclideCompletionParser* self, const gchar* word);
gboolean euclide_completion_parser_get_for_word (EuclideCompletionParser* self, const gchar* to_find, GeeTreeSet* * list);
void euclide_completion_parser_rebuild_word_list (EuclideCompletionParser* self, GtkTextView* view);
void euclide_completion_parser_parse_text_view (EuclideCompletionParser* self, GtkTextView* view);
static gboolean euclide_completion_parser_parse_string (EuclideCompletionParser* self, const gchar* text);
void euclide_completion_parser_cancel_parsing (EuclideCompletionParser* self);
static void euclide_completion_parser_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gint string_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_;
	gunichar _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1039 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1040 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1040 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = c;
#line 1040 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = g_utf8_strchr (((gchar*) self) + _tmp0_, (gssize) -1, _tmp1_);
#line 1040 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1042 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1042 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 114 "engine.c"
		gchar* _tmp4_;
#line 1043 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1043 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1043 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 122 "engine.c"
	} else {
#line 1045 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = -1;
#line 1045 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 128 "engine.c"
	}
}


gboolean euclide_completion_parser_is_delimiter (EuclideCompletionParser* self, gunichar c) {
	gboolean result = FALSE;
	gunichar _tmp0_;
	gint _tmp1_;
#line 26 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = c;
#line 27 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp1_ = string_index_of_char (EUCLIDE_COMPLETION_PARSER_delimiters, _tmp0_, 0);
#line 27 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	result = _tmp1_ >= 0;
#line 27 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	return result;
#line 147 "engine.c"
}


EuclideCompletionParser* euclide_completion_parser_construct (GType object_type) {
	EuclideCompletionParser * self = NULL;
	GeeHashMap* _tmp0_;
#line 36 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self = (EuclideCompletionParser*) g_object_new (object_type, NULL);
#line 37 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = gee_hash_map_new (gtk_text_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 37 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_object_unref0 (self->text_view_words);
#line 37 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->text_view_words = _tmp0_;
#line 36 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	return self;
#line 164 "engine.c"
}


EuclideCompletionParser* euclide_completion_parser_new (void) {
#line 36 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	return euclide_completion_parser_construct (EUCLIDE_COMPLETION_TYPE_PARSER);
#line 171 "engine.c"
}


void euclide_completion_parser_add_last_word (EuclideCompletionParser* self) {
	const gchar* _tmp0_;
#line 40 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = self->priv->last_word;
#line 41 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	euclide_completion_parser_add_word (self, _tmp0_);
#line 183 "engine.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	return self ? g_object_ref (self) : NULL;
#line 190 "engine.c"
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_;
	glong _tmp16_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	gchar* _tmp21_;
#line 1363 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1365 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1365 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 223 "engine.c"
		glong _tmp3_;
		glong _tmp4_;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 232 "engine.c"
	}
#line 1368 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1368 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 238 "engine.c"
		glong _tmp6_;
		glong _tmp7_;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 247 "engine.c"
	}
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 253 "engine.c"
		glong _tmp10_;
		glong _tmp11_;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 262 "engine.c"
	} else {
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 266 "engine.c"
	}
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp8_, NULL);
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp13_ = end;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp13_ >= ((glong) 0)) {
#line 274 "engine.c"
		glong _tmp14_;
		glong _tmp15_;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = end;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = _tmp14_ <= _tmp15_;
#line 283 "engine.c"
	} else {
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = FALSE;
#line 287 "engine.c"
	}
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp16_ = start;
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp17_ = end;
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp21_;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 309 "engine.c"
}


gboolean euclide_completion_parser_get_for_word (EuclideCompletionParser* self, const gchar* to_find, GeeTreeSet* * list) {
	GeeTreeSet* _vala_list = NULL;
	gboolean result = FALSE;
	guint length = 0U;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeTreeSet* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeTreeSet* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	GError * _inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_val_if_fail (to_find != NULL, FALSE);
#line 45 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = to_find;
#line 45 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp1_ = strlen (_tmp0_);
#line 45 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp2_ = _tmp1_;
#line 45 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	length = (guint) _tmp2_;
#line 46 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp3_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 46 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_object_unref0 (_vala_list);
#line 46 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_vala_list = _tmp3_;
#line 47 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp4_ = to_find;
#line 47 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 47 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_free0 (self->priv->last_word);
#line 47 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->priv->last_word = _tmp5_;
#line 48 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp6_ = self->priv->words;
#line 48 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	if (_tmp6_ != NULL) {
#line 358 "engine.c"
		{
			GeeArrayList* _tmp7_;
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp7_ = self->priv->words;
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_rec_mutex_lock (&self->priv->__lock_words);
#line 365 "engine.c"
			{
				{
					GeeArrayList* _word_list = NULL;
					GeeArrayList* _tmp8_;
					GeeArrayList* _tmp9_;
					gint _word_size = 0;
					GeeArrayList* _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
					gint _word_index = 0;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_tmp8_ = self->priv->words;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_tmp9_ = _g_object_ref0 (_tmp8_);
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_word_list = _tmp9_;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_tmp10_ = _word_list;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_tmp12_ = _tmp11_;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_word_size = _tmp12_;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_word_index = -1;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					while (TRUE) {
#line 394 "engine.c"
						gint _tmp13_;
						gint _tmp14_;
						gint _tmp15_;
						gchar* word = NULL;
						GeeArrayList* _tmp16_;
						gint _tmp17_;
						gpointer _tmp18_;
						gboolean _tmp19_ = FALSE;
						const gchar* _tmp20_;
						gint _tmp21_;
						gint _tmp22_;
						guint _tmp23_;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp13_ = _word_index;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_word_index = _tmp13_ + 1;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp14_ = _word_index;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp15_ = _word_size;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						if (!(_tmp14_ < _tmp15_)) {
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							break;
#line 419 "engine.c"
						}
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp16_ = _word_list;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp17_ = _word_index;
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _tmp17_);
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						word = (gchar*) _tmp18_;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp20_ = word;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp21_ = strlen (_tmp20_);
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp22_ = _tmp21_;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_tmp23_ = length;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						if (((guint) _tmp22_) > _tmp23_) {
#line 439 "engine.c"
							const gchar* _tmp24_;
							guint _tmp25_;
							gchar* _tmp26_;
							gchar* _tmp27_;
							const gchar* _tmp28_;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp24_ = word;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp25_ = length;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp26_ = string_slice (_tmp24_, (glong) 0, (glong) _tmp25_);
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp27_ = _tmp26_;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp28_ = to_find;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp19_ = g_strcmp0 (_tmp27_, _tmp28_) == 0;
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_g_free0 (_tmp27_);
#line 459 "engine.c"
						} else {
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp19_ = FALSE;
#line 463 "engine.c"
						}
#line 51 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						if (_tmp19_) {
#line 467 "engine.c"
							GeeTreeSet* _tmp29_;
							const gchar* _tmp30_;
#line 52 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp29_ = _vala_list;
#line 52 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							_tmp30_ = word;
#line 52 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 476 "engine.c"
						}
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
						_g_free0 (word);
#line 480 "engine.c"
					}
#line 50 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_g_object_unref0 (_word_list);
#line 484 "engine.c"
				}
			}
			__finally3:
			{
				GeeArrayList* _tmp31_;
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp31_ = self->priv->words;
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				g_rec_mutex_unlock (&self->priv->__lock_words);
#line 494 "engine.c"
			}
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 498 "engine.c"
				gboolean _tmp32_ = FALSE;
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				return _tmp32_;
#line 506 "engine.c"
			}
		}
	}
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp33_ = _vala_list;
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp34_ = gee_collection_get_is_empty ((GeeCollection*) _tmp33_);
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp35_ = _tmp34_;
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	result = !_tmp35_;
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	if (list) {
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		*list = _vala_list;
#line 522 "engine.c"
	} else {
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_g_object_unref0 (_vala_list);
#line 526 "engine.c"
	}
#line 58 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	return result;
#line 530 "engine.c"
}


void euclide_completion_parser_rebuild_word_list (EuclideCompletionParser* self, GtkTextView* view) {
	GtkTextView* _tmp3_;
	GError * _inner_error_ = NULL;
#line 61 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (view != NULL);
#line 541 "engine.c"
	{
		GeeArrayList* _tmp0_;
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp0_ = self->priv->words;
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		g_rec_mutex_lock (&self->priv->__lock_words);
#line 548 "engine.c"
		{
			GeeArrayList* _tmp1_;
#line 63 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp1_ = self->priv->words;
#line 63 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 555 "engine.c"
		}
		__finally4:
		{
			GeeArrayList* _tmp2_;
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp2_ = self->priv->words;
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_rec_mutex_unlock (&self->priv->__lock_words);
#line 564 "engine.c"
		}
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_clear_error (&_inner_error_);
#line 62 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			return;
#line 574 "engine.c"
		}
	}
#line 65 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp3_ = view;
#line 65 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	euclide_completion_parser_parse_text_view (self, _tmp3_);
#line 581 "engine.c"
}


void euclide_completion_parser_parse_text_view (EuclideCompletionParser* self, GtkTextView* view) {
	GtkTextView* _tmp9_;
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 68 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 68 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (view != NULL);
#line 600 "engine.c"
	{
		GeeArrayList* _tmp0_;
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp0_ = self->priv->words;
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		g_rec_mutex_lock (&self->priv->__lock_words);
#line 607 "engine.c"
		{
			GeeHashMap* _tmp1_;
			GtkTextView* _tmp2_;
			gboolean _tmp3_;
#line 71 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp1_ = self->text_view_words;
#line 71 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp2_ = view;
#line 71 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, _tmp2_);
#line 71 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			if (_tmp3_) {
#line 620 "engine.c"
				GeeHashMap* _tmp4_;
				GtkTextView* _tmp5_;
				gpointer _tmp6_;
#line 72 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp4_ = self->text_view_words;
#line 72 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp5_ = view;
#line 72 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 72 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_g_object_unref0 (self->priv->words);
#line 72 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				self->priv->words = (GeeArrayList*) _tmp6_;
#line 634 "engine.c"
			} else {
				GeeArrayList* _tmp7_;
#line 75 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp7_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 75 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_g_object_unref0 (self->priv->words);
#line 75 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				self->priv->words = _tmp7_;
#line 643 "engine.c"
			}
		}
		__finally5:
		{
			GeeArrayList* _tmp8_;
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp8_ = self->priv->words;
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_rec_mutex_unlock (&self->priv->__lock_words);
#line 653 "engine.c"
		}
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_clear_error (&_inner_error_);
#line 70 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			return;
#line 663 "engine.c"
		}
	}
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp9_ = view;
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp10_ = gtk_text_view_get_buffer (_tmp9_);
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp11_ = _tmp10_;
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_object_get (_tmp11_, "text", &_tmp12_, NULL);
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp13_ = _tmp12_;
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp14_ = _tmp13_;
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp15_ = strlen (_tmp14_);
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp16_ = _tmp15_;
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp17_ = _tmp16_ > 0;
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_free0 (_tmp14_);
#line 79 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	if (_tmp17_) {
#line 688 "engine.c"
		GtkTextView* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextBuffer* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GeeHashMap* _tmp24_;
		GtkTextView* _tmp25_;
		GeeArrayList* _tmp26_;
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp18_ = view;
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp19_ = gtk_text_view_get_buffer (_tmp18_);
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp20_ = _tmp19_;
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		g_object_get (_tmp20_, "text", &_tmp21_, NULL);
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp22_ = _tmp21_;
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp23_ = _tmp22_;
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		euclide_completion_parser_parse_string (self, _tmp23_);
#line 80 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_g_free0 (_tmp23_);
#line 81 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp24_ = self->text_view_words;
#line 81 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp25_ = view;
#line 81 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		_tmp26_ = self->priv->words;
#line 81 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, _tmp25_, _tmp26_);
#line 722 "engine.c"
	}
}


static void euclide_completion_parser_add_word (EuclideCompletionParser* self, const gchar* word) {
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeArrayList* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
#line 85 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 85 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (word != NULL);
#line 86 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = word;
#line 86 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp1_ = strlen (_tmp0_);
#line 86 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp2_ = _tmp1_;
#line 86 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	if (_tmp2_ < EUCLIDE_COMPLETION_PARSER_MINIMUM_WORD_LENGTH) {
#line 87 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		return;
#line 749 "engine.c"
	}
#line 89 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp3_ = self->priv->words;
#line 89 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp4_ = word;
#line 89 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 89 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	if (!_tmp5_) {
#line 759 "engine.c"
		{
			GeeArrayList* _tmp6_;
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp6_ = self->priv->words;
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			g_rec_mutex_lock (&self->priv->__lock_words);
#line 766 "engine.c"
			{
				GeeArrayList* _tmp7_;
				const gchar* _tmp8_;
#line 91 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp7_ = self->priv->words;
#line 91 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp8_ = word;
#line 91 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 776 "engine.c"
			}
			__finally6:
			{
				GeeArrayList* _tmp9_;
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp9_ = self->priv->words;
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				g_rec_mutex_unlock (&self->priv->__lock_words);
#line 785 "engine.c"
			}
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				g_clear_error (&_inner_error_);
#line 90 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				return;
#line 795 "engine.c"
			}
		}
	}
}


void euclide_completion_parser_cancel_parsing (EuclideCompletionParser* self) {
#line 96 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->parsing_cancelled = TRUE;
#line 807 "engine.c"
}


static gboolean euclide_completion_parser_parse_string (EuclideCompletionParser* self, const gchar* text) {
	gboolean result = FALSE;
	gchar** word_array = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint word_array_length1;
	gint _word_array_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 100 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 101 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->parsing_cancelled = FALSE;
#line 102 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = text;
#line 102 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp2_ = _tmp1_ = g_strsplit_set (_tmp0_, EUCLIDE_COMPLETION_PARSER_delimiters, EUCLIDE_COMPLETION_PARSER_MAX_TOKENS);
#line 102 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	word_array = _tmp2_;
#line 102 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	word_array_length1 = _vala_array_length (_tmp1_);
#line 102 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_word_array_size_ = word_array_length1;
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp3_ = word_array;
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp3__length1 = word_array_length1;
#line 841 "engine.c"
	{
		gchar** current_word_collection = NULL;
		gint current_word_collection_length1 = 0;
		gint _current_word_collection_size_ = 0;
		gint current_word_it = 0;
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		current_word_collection = _tmp3_;
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		current_word_collection_length1 = _tmp3__length1;
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
		for (current_word_it = 0; current_word_it < _tmp3__length1; current_word_it = current_word_it + 1) {
#line 853 "engine.c"
			gchar* _tmp4_;
			gchar* current_word = NULL;
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			_tmp4_ = g_strdup (current_word_collection[current_word_it]);
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
			current_word = _tmp4_;
#line 860 "engine.c"
			{
				gboolean _tmp5_;
				const gchar* _tmp6_;
#line 104 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp5_ = self->parsing_cancelled;
#line 104 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				if (_tmp5_) {
#line 105 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					g_debug ("engine.vala:105: Cancelling parse");
#line 106 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					result = FALSE;
#line 106 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					_g_free0 (current_word);
#line 106 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
#line 106 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
					return result;
#line 878 "engine.c"
				}
#line 108 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_tmp6_ = current_word;
#line 108 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				euclide_completion_parser_add_word (self, _tmp6_);
#line 103 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
				_g_free0 (current_word);
#line 886 "engine.c"
			}
		}
	}
#line 110 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	result = TRUE;
#line 110 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
#line 110 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	return result;
#line 896 "engine.c"
}


static void euclide_completion_parser_class_init (EuclideCompletionParserClass * klass) {
#line 21 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	euclide_completion_parser_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_type_class_add_private (klass, sizeof (EuclideCompletionParserPrivate));
#line 21 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	G_OBJECT_CLASS (klass)->finalize = euclide_completion_parser_finalize;
#line 907 "engine.c"
}


static void euclide_completion_parser_instance_init (EuclideCompletionParser * self) {
	gchar* _tmp0_;
#line 21 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->priv = EUCLIDE_COMPLETION_PARSER_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->parsing_cancelled = FALSE;
#line 33 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_rec_mutex_init (&self->priv->__lock_words);
#line 34 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_tmp0_ = g_strdup ("");
#line 34 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self->priv->last_word = _tmp0_;
#line 923 "engine.c"
}


static void euclide_completion_parser_finalize (GObject * obj) {
	EuclideCompletionParser * self;
#line 21 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParser);
#line 30 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_object_unref0 (self->text_view_words);
#line 33 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	g_rec_mutex_clear (&self->priv->__lock_words);
#line 33 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_object_unref0 (self->priv->words);
#line 34 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	_g_free0 (self->priv->last_word);
#line 21 "/builddir/build/BUILD/scratch-text-editor-2.4.1/plugins/word-completion/engine.vala"
	G_OBJECT_CLASS (euclide_completion_parser_parent_class)->finalize (obj);
#line 941 "engine.c"
}


GType euclide_completion_parser_get_type (void) {
	return euclide_completion_parser_type_id;
}


GType euclide_completion_parser_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (EuclideCompletionParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) euclide_completion_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EuclideCompletionParser), 0, (GInstanceInitFunc) euclide_completion_parser_instance_init, NULL };
	euclide_completion_parser_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "EuclideCompletionParser", &g_define_type_info, 0);
	return euclide_completion_parser_type_id;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



